
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>部署Python的框架下的web app的详细教程 / iVAN</title>

    <meta name="description" content="部署Python的框架下的web app的详细教程   这篇文章主要介绍了Python部署web app的详细教程,示例代码基于Python2.x版本,需要的朋友可以参考下 作为一个合格的开发者,在本地环境下完成开发还远远不够,我们需要把Web App部署到远程服务器上,这样,广大用户才能访问到网站. 很多做开发的同学把部署这件事情看成是运维同学的工作,这种看法是完全错误的.首先,最近流行DevOps理念,就是说,开发和运维要变成一个整体.其次,运维的难度,其实跟开发质量有很大的关系.代码写得垃圾,运维再好也架不住天天挂掉.最后,DevOps理念">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">部署Python的框架下的web app的详细教程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> 　　这篇文章主要介绍了Python部署web app的详细教程,示例代码基于Python2.x版本,需要的朋友可以参考下</p>
<p>　　作为一个合格的开发者，在本地环境下完成开发还远远不够，我们需要把Web App部署到远程服务器上，这样，广大用户才能访问到网站。</p>
<p>　　很多做开发的同学把部署这件事情看成是运维同学的工作，这种看法是完全错误的。首先，最近流行DevOps理念，就是说，开发和运维要变成一个整体。其次，运维的难度，其实跟开发质量有很大的关系。代码写得垃圾，运维再好也架不住天天挂掉。最后，DevOps理念需要把运维、监控等功能融入到开发中。你想服务器升级时不中断用户服务?那就得在开发时考虑到这一点。</p>
<p>　　下面，我们就来把awesome-python-webapp部署到Linux服务器。</p>
<p>　　搭建Linux服务器</p>
<p>　　要部署到Linux，首先得有一台Linux服务器。要在公网上体验的同学，可以在Amazon的AWS申请一台EC2虚拟机(免费使用1年)，或者使用国内的一些云服务器，一般都提供Ubuntu  Server的镜像。想在本地部署的同学，请安装虚拟机，推荐使用VirtualBox。</p>
<p>　　我们选择的Linux服务器版本是Ubuntu Server 12.04  LTS，原因是apt太简单了。如果你准备使用其他Linux版本，也没有问题。</p>
<p>　　Linux安装完成后，请确保ssh服务正在运行，否则，需要通过apt安装：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ sudo  apt-get install openssh-server</p>
</td>
</tr>
</tbody>
</table>
<p>　　有了ssh服务，就可以从本地连接到服务器上。建议把公钥复制到服务器端用户的.ssh/authorized_keys中，这样，就可以通过证书实现无密码连接。</p>
<p>　　部署方式</p>
<p>　　在本地开发时，我们可以用Python自带的WSGI服务器，但是，在服务器上，显然不能用自带的这个开发版服务器。可以选择的WSGI服务器很多，我们选gunicorn：它用类似Nginx的Master-Worker模式，同时可以提供gevent的支持，不用修改代码，就能获得极高的性能。</p>
<p>　　此外，我们还需要一个高性能Web服务器，这里选择Nginx，它可以处理静态资源，同时作为反向代理把动态请求交给gunicorn处理。gunicorn负责调用我们的Python代码，这个模型如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g1Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vZTAzNWY4NjM5ZjlmMDg3ZjdiMTQ2ZjRhNjEwYzRhOWMucG5n.jpg"><br />　　Nginx负责分发请求：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g1Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vZWNkZTczYWJkMWI3YjY5MGY4NTJiOThlYzE4ZGMwNDQucG5n.jpg"><br />　　在服务器端，我们需要定义好部署的目录结构：</p>
<p>　　复制代码 代码如下:</p>
<p>　　/</p>
<p>　　+- srv/</p>
<p>　　+- awesome/ &lt;-- Web App根目录</p>
<p>　　+- www/ &lt;-- 存放Python源码</p>
<p>　　| +- static/ &lt;-- 存放静态资源文件</p>
<p>　　+- log/ &lt;-- 存放log</p>
<p>　　在服务器上部署，要考虑到新版本如果运行不正常，需要回退到旧版本时怎么办。每次用新的代码覆盖掉旧的文件是不行的，需要一个类似版本控制的机制。由于Linux系统提供了软链接功能，所以，我们把www作为一个软链接，它指向哪个目录，哪个目录就是当前运行的版本：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g1Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vYjA4Mzk3ZjJkZDU5NGY0ZWE1OTBhMDgxNTdiN2EwNDkucG5n.jpg"><br />　　而Nginx和gunicorn的配置文件只需要指向www目录即可。</p>
<p>　　Nginx可以作为服务进程直接启动，但gunicorn还不行，所以，Supervisor登场!Supervisor是一个管理进程的工具，可以随系统启动而启动服务，它还时刻监控服务进程，如果服务进程意外退出，Supervisor可以自动重启服务。</p>
<p>　　总结一下我们需要用到的服务有：</p>
<p>　　Nginx：高性能Web服务器+负责反向代理;</p>
<p>　　gunicorn：高性能WSGI服务器;</p>
<p>　　gevent：把Python同步代码变成异步协程的库;</p>
<p>　　Supervisor：监控服务进程的工具;</p>
<p>　　MySQL：数据库服务。</p>
<p>　　在Linux服务器上用apt可以直接安装上述服务：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ sudo  apt-get install nginx gunicorn python-gevent supervisor  mysql-server</p>
</td>
</tr>
</tbody>
</table>
<p>　　然后，再把我们自己的Web App用到的Python库安装了：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ sudo  apt-get install python-jinja2  python-mysql.connector</p>
</td>
</tr>
</tbody>
</table>
<p>　　在服务器上创建目录/srv/awesome/以及相应的子目录。</p>
<p>　　在服务器上初始化MySQL数据库，把数据库初始化脚本schema.sql复制到服务器上执行：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ mysql -u root -p &lt;  schema.sql</p>
</td>
</tr>
</tbody>
</table>
<p>　　服务器端准备就绪。</p>
<p>　　部署</p>
<p>　　用FTP还是SCP还是rsync复制文件?如果你需要手动复制，用一次两次还行，一天如果部署50次不但慢、效率低，而且容易出错。</p>
<p>　　正确的部署方式是使用工具配合脚本完成自动化部署。Fabric就是一个自动化部署工具。由于Fabric是用Python开发的，所以，部署脚本也是用Python来编写，非常方便!</p>
<p>　　要用Fabric部署，需要在本机(是开发机器，不是Linux服务器)安装Fabric：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ easy_install  fabric</p>
</td>
</tr>
</tbody>
</table>
<p>　　Linux服务器上不需要安装Fabric，Fabric使用SSH直接登录服务器并执行部署命令。</p>
<p>　　下一步是编写部署脚本。Fabric的部署脚本叫fabfile.py，我们把它放到awesome-python-webapp的目录下，与www目录平级：</p>
<p>　　复制代码 代码如下:</p>
<p>　　awesome-python-webapp/</p>
<p>　　+- fabfile.py</p>
<p>　　+- www/</p>
<p>　　+- ...</p>
<p>　　Fabric的脚本编写很简单，首先导入Fabric的API，设置部署时的变量：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11<br />
            12<br />
            13<br />
            14<br />
            15<br />
            16<br />
            17
            </td>
<td>
<p># fabfile.py<br />
            import os,  re<br />
            from datetime import  datetime<br />
             <br />
            # 导入Fabric API:<br />
            from fabric.api import  *<br />
             <br />
            # 服务器登录用户名:<br />
            env.user = 'michael'<br />
            # sudo用户为root:<br />
            env.sudo_user =  'root'<br />
            # 服务器地址，可以有多个，依次部署:<br />
            env.hosts = ['192.168.0.3']<br />
             <br />
            # 服务器MySQL用户名和口令:<br />
            db_user = 'www-data'<br />
            db_password =  'www-data'</p>
</td>
</tr>
</tbody>
</table>
<p>　　然后，每个Python函数都是一个任务。我们先编写一个打包的任务：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11
            </td>
<td>
<p>_TAR_FILE = 'dist-awesome.tar.gz'<br />
             <br />
            def build():<br />
            includes = ['static', 'templates', 'transwarp', 'favicon.ico', '*.py']<br />
            excludes = ['test', '.*', '*.pyc', '*.pyo']<br />
            local('rm -f  dist/%s' % _TAR_FILE)<br />
            with  lcd(os.path.join(os.path.abspath('.'), 'www')):<br />
            cmd = ['tar', '--dereference', '-czvf', '../dist/%s'  % _TAR_FILE]<br />
            cmd.extend(['--exclude='%s'' % ex for ex in excludes])<br />
            cmd.extend(includes)<br />
            local('  '.join(cmd))</p>
</td>
</tr>
</tbody>
</table>
<p>　　Fabric提供local('...')来运行本地命令，with  lcd(path)可以把当前命令的目录设定为lcd()指定的目录，注意Fabric只能运行命令行命令，Windows下可能需要Cgywin环境。</p>
<p>　　在awesome-python-webapp目录下运行：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ fab build</p>
</td>
</tr>
</tbody>
</table>
<p>　　看看是否在dist目录下创建了dist-awesome.tar.gz的文件。</p>
<p>　　打包后，我们就可以继续编写deploy任务，把打包文件上传至服务器，解压，重置www软链接，重启相关服务：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11<br />
            12<br />
            13<br />
            14<br />
            15<br />
            16<br />
            17<br />
            18<br />
            19<br />
            20<br />
            21<br />
            22<br />
            23<br />
            24<br />
            25<br />
            26
            </td>
<td>
<p>_REMOTE_TMP_TAR =  '/tmp/%s' % _TAR_FILE<br />
            _REMOTE_BASE_DIR = '/srv/awesome'<br />
             <br />
            def deploy():<br />
            newdir = 'www-%s' % datetime.now().strftime('%y-%m-%d_%H.%M.%S')<br />
            # 删除已有的tar文件:<br />
            run('rm -f  %s' %  _REMOTE_TMP_TAR)<br />
            # 上传新的tar文件:<br />
            put('dist/%s' % _TAR_FILE, _REMOTE_TMP_TAR)<br />
            # 创建新目录:<br />
            with cd(_REMOTE_BASE_DIR):<br />
            sudo('mkdir  %s' %  newdir)<br />
            # 解压到新目录:<br />
            with cd('%s/%s' % (_REMOTE_BASE_DIR, newdir)):<br />
            sudo('tar  -xzvf %s' % _REMOTE_TMP_TAR)<br />
            # 重置软链接:<br />
            with cd(_REMOTE_BASE_DIR):<br />
            sudo('rm -f  www')<br />
            sudo('ln -s  %s www' % newdir)<br />
            sudo('chown  www-data:www-data www')<br />
            sudo('chown  -R www-data:www-data %s' % newdir)<br />
            # 重启Python服务和nginx服务器:<br />
            with settings(warn_only=True):<br />
            sudo('supervisorctl stop awesome')<br />
            sudo('supervisorctl start awesome')<br />
            sudo('/etc/init.d/nginx reload')</p>
</td>
</tr>
</tbody>
</table>
<p>　　注意run()函数执行的命令是在服务器上运行，with cd(path)和with  lcd(path)类似，把当前目录在服务器端设置为cd()指定的目录。如果一个命令需要sudo权限，就不能用run()，而是用sudo()来执行。</p>
<p>　　配置Supervisor</p>
<p>　　上面让Supervisor重启gunicorn的命令会失败，因为我们还没有配置Supervisor呢。</p>
<p>　　编写一个Supervisor的配置文件awesome.conf，存放到/etc/supervisor/conf.d/目录下：</p>
<p>　　复制代码 代码如下:</p>
<p>　　[program:awesome]</p>
<p>　　command = /usr/bin/gunicorn --bind 127.0.0.1:9000 --workers 1  --worker-class gevent wsgiapp:application</p>
<p>　　directory = /srv/awesome/www</p>
<p>　　user = www-data</p>
<p>　　startsecs = 3</p>
<p>　　redirect_stderr = true</p>
<p>　　stdout_logfile_maxbytes = 50MB</p>
<p>　　stdout_logfile_backups = 10</p>
<p>　　stdout_logfile = /srv/awesome/log/app.log</p>
<p>　　配置文件通过[program:awesome]指定服务名为awesome，command指定启动gunicorn的命令行，设定gunicorn的启动端口为9000，WSGI处理函数入口为wsgiapp:application。</p>
<p>　　然后重启Supervisor后，就可以随时启动和停止Supervisor管理的服务了：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4
            </td>
<td>
<p>$ sudo  supervisorctl reload<br />
            $ sudo  supervisorctl start awesome<br />
            $ sudo  supervisorctl status<br />
            awesome RUNNING pid 1401, uptime  5:01:34</p>
</td>
</tr>
</tbody>
</table>
<p>　　配置Nginx</p>
<p>　　Supervisor只负责运行gunicorn，我们还需要配置Nginx。把配置文件awesome放到/etc/nginx/sites-available/目录下：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11<br />
            12<br />
            13<br />
            14<br />
            15<br />
            16<br />
            17<br />
            18<br />
            19<br />
            20<br />
            21<br />
            22<br />
            23<br />
            24<br />
            25<br />
            26<br />
            27
            </td>
<td>
<p>server {<br />
            listen 80; # 监听80端口<br />
             <br />
            root /srv/awesome/www;<br />
            access_log /srv/awesome/log/access_log;<br />
            error_log /srv/awesome/log/error_log;<br />
             <br />
            # server_name awesome.liaoxuefeng.com; #  配置域名<br />
             <br />
            # 处理静态文件/favicon.ico:<br />
            location /favicon.ico {<br />
            root /srv/awesome/www;<br />
            }<br />
             <br />
            # 处理静态资源:<br />
            location ~ ^/static/.*$ {<br />
            root /srv/awesome/www;<br />
            }<br />
             <br />
            # 动态请求转发到9000端口(gunicorn):<br />
            location / {<br />
            proxy_pass http://127.0.0.1:9000;<br />
            proxy_set_header X-Real-IP $remote_addr;<br />
            proxy_set_header Host $host;<br />
            proxy_set_header X-Forwarded-For  $proxy_add_x_forwarded_for;<br />
            }<br />
            }</p>
</td>
</tr>
</tbody>
</table>
<p>　　然后在/etc/nginx/sites-enabled/目录下创建软链接：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3
            </td>
<td>
<p>$ pwd<br />
            /etc/nginx/sites-enabled<br />
            $ sudo  ln -s /etc/nginx/sites-available/awesome .</p>
</td>
</tr>
</tbody>
</table>
<p>　　让Nginx重新加载配置文件，不出意外，我们的awesome-python-webapp应该正常运行：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1
            </td>
<td>
<p>$ sudo  /etc/init.d/nginx reload</p>
</td>
</tr>
</tbody>
</table>
<p>　　如果有任何错误，都可以在/srv/awesome/log下查找Nginx和App本身的log。如果Supervisor启动时报错，可以在/var/log/supervisor下查看Supervisor的log。</p>
<p>　　如果一切顺利，你可以在浏览器中访问Linux服务器上的awesome-python-webapp了：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g1Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vYjA4Mzk3ZjJkZDU5NGY0ZWE1OTBhMDgxNTdiN2EwNDkucG5n.jpg"><br />　　如果在开发环境更新了代码，只需要在命令行执行：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2
            </td>
<td>
<p>$ fab build<br />
            $ fab deploy</p>
</td>
</tr>
</tbody>
</table>
<p>　　自动部署完成!刷新浏览器就可以看到服务器代码更新后的效果。</p>
<p></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:07:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e6%9c%ac%e5%9c%b0/" title="本地">本地</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>, <a href="https://www.iamivan.net/tag/%e5%bc%80%e5%8f%91/" title="开发">开发</a>, <a href="https://www.iamivan.net/tag/python-web%e5%bc%80%e5%8f%91/" title="python web开发">python web开发</a>, <a href="https://www.iamivan.net/tag/ssh%e5%8d%87%e7%ba%a7/" title="ssh升级">ssh升级</a>, <a href="https://www.iamivan.net/tag/app%e5%8a%a8%e6%80%81web%e5%bc%80%e5%8f%91/" title="app动态web开发">app动态web开发</a>, <a href="https://www.iamivan.net/tag/nginx%e8%99%9a%e6%8b%9f%e6%9c%bajava-web/" title="nginx虚拟机java web">nginx虚拟机java web</a>, <a href="https://www.iamivan.net/tag/web%e9%83%a8%e7%bd%b2/" title="web部署">web部署</a>, <a href="https://www.iamivan.net/tag/%e7%83%ad%e9%83%a8%e7%bd%b2-java-web-%e8%bf%90%e7%bb%b4/" title="热部署 java web 运维">热部署 java web 运维</a>, <a href="https://www.iamivan.net/tag/%e8%bf%90%e7%bb%b4%e9%83%a8%e7%bd%b2/" title="运维部署">运维部署</a>, <a href="https://www.iamivan.net/tag/ssh%e6%a1%86%e6%9e%b6%e9%93%be%e6%8e%a5%e9%97%ae%e9%a2%98/" title="ssh框架链接问题">ssh框架链接问题</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81java-web%e6%a1%86%e6%9e%b6ssh/" title="代码java web框架ssh">代码java web框架ssh</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>部署Python的框架下的web app的详细教程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZAXAz.html" rel="bookmark">在Java的Struts框架下进行web编程的入门教程&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当点击一个超链接或提交一个HTML表单在Struts2 的 Web应用程序,输入所收集被发送到一个Java类称为操作控制器.当动作执行后,结果选择了一个资源来呈现响应.资源通常是一个JSP,但它也可以是一个PDF文件,Excel电子表格,或一个Java applet 窗口. 假设已经建立开发环境.现在让我们继续为第一个 &quot;Hello World&quot; 的 struts2 项目构建.这个项目的目的是建立一个Web应用程序,它收集用户的姓名,并显示&quot;Hello World&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWKq3EM.html" rel="bookmark">window下homestead开发环境安装详细教程&lowbar;win服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.资源准备 链接:http://pan.baidu.com/s/1mh7qUBe 密码:p4wx 1. virtualbox.box文件放在C盘根目录上. 2. metadata.json文件放在C盘用户目录上.比如我的是 C:\Users\pc 3. Git-2.9.3-64-bit.exe 下载安装,全部默认就好. 4. vagrant_1.8.5.msi 下载安装. 5. VirtualBox-5.1.4-110228-Win.exe 下载安装. 二.简介 1. 什么是vagrant?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY5ZlxM.html" rel="bookmark">CentOS 7&period;x下的LEMP环境搭建详细教程&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近由于项目需求,将服务器从CentOS6升级到CentOS7,对应的PHP版本也升级到PHP5.6.我们熟悉的有LEMP环境一键安装包,但是本文我们将单独安装各个组件模块,并搭建一个完整的PHP运行平台. 我们常说的LNMP环境是指Linux/nginx/MySQL/PHP组合,而LEMP是什么呢?其实Nginx的发音是Engine-X = E,LEMP包是由Linux.nginx.MariaDB/MySQL和PHP组成的,那么看来LEMP和LNMP是一样的,而现在业内习惯性的称作LEMP.M			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV7Rglb.html" rel="bookmark">在Python的Flask框架下使用sqlalchemy库的简单教程&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				flask中的sqlalchemy 相比于sqlalchemy封装的更加彻底一些 , 在一些方法上更简单 首先import类库: 在CODE上查看代码片派生到我的代码片 &lt;span style=&quot;font-size:18px;&quot;&gt;from flask import Flask from flask.ext.sqlalchemy import SQLAlchemy&lt;/span&gt;   然后,需要加载 数据库路径 在CODE上查看代码片派生到我的代码片 &lt;spa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXBy1Ab.html" rel="bookmark">linux下配置web&plus;ftp服务器全教程（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近公司上了个服务器,顺便整理下各部门的网站,搞的异常忙碌,今天终于闲下来了整理一下这几天遇到的问题和一些想法,今天首要写的是一篇完整版的教程:linux(fedora.redhat)下配置web+ftp服务器.相信很多站长到你在更换vps或者独立服务器的时候都会用到,收藏下来备用吧. 一.环境需求 根据不同的网站负载(访问量强度)选择适合自己的服务器或者vps,特别是当你申请到一台服务器的时候,首要做的就是寻找一家可靠的服务器托管机房,将服务器托管到里面,使服务器可以在公网上保持一个较好的访问			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYYWPb.html" rel="bookmark">linux下AWstats 安装与配置详细教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.到以下网站下载awstats和cronolog安装包: http://sourceforge.net/projects/awstats/ http://www.cronolog.org 2.解压和安装文件 1)tar xzvf awstats-version.tgz 如下: data docs README.TXT tools wwwroot (1)默认安装方法 进入tools目录运行awstats_configure.pl文件: perl awstats_configure.pl 按提示对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr21o1M.html" rel="bookmark">针对PHP环境下Fckeditor编辑器上传图片配置详细教程&lowbar;网页编辑器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开启Fckeditor上传图片功能 考虑到目录安全性问题,默认Fckeditor2.6.6上传功能并未开启,所以第一步我们必须开启Fckeditor上传功能,这里需要注意,由于PHP版本Fckeditor上传功能需要用到chomod函数对新建目录进行权限设置,所以请务必确认在启用Fckeditor上传功能时PHP环境的用户具有创建和更改上传目录的权限. 如果没有开启Fckeditor上传功能,在点击插入/编辑图像按钮,选择上传,在选择完要上传的文件后点击发送到服务器上按钮时会报错误信息如下 复制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXxeY5p.html" rel="bookmark">linux中ubuntu下手动编译php-amqp扩展详细教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP官网的amqp模块介绍在此,我也不多介绍.下面进入重点的安装环节. http://www.php.net/manual/en/book.amqp.php 用于ubuntu的默认源里面没有php5-amqp这个包,所以要用上amqp得考手动编译. 准备工作: # 安装php编译工具 sudo apt-get install php5-dev # 安装rabbitmq的库 sudo apt-get install librabbitmq-dev 然后如果你没有安装git话请安装一下git,因为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGxxrp.html" rel="bookmark">win7下蓝牙耳机连接电脑的详细教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  1.首先确认电脑的蓝牙是在开启状态,蓝牙灯显示正常,并且开启蓝牙耳机的开关; 2.接着点击电脑上右下角蓝牙图标,选择&quot;添加设备&quot;选项; 3.选择要添加的蓝牙耳机,系统会提示正在与蓝牙适配器连接,等待一会会提示添加成功; 4.接着点击&quot;开始&quot;按钮,菜单中选择点击&quot;设备和打印机&quot;,这时候就可以看到添加的蓝牙耳机了. 6.鼠标右击蓝牙耳机选择&quot;属性&quot;,在弹出的窗口中选择&quot;服务&quot;选项卡,这里一定要勾选耳机的选项			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp57jRb.html" rel="bookmark" class="title">实例分析中小企业站优化的常见误区</a>
					<div>
						笔者很长一段时间一直服务企业站的优化,本文结合自己站点与同行网站的优化,来谈谈一些企业站优化思路上的误区.而不是讲类似首页图多文字少,首页flash,框架结构等等这些. 一.关键词堆砌篇 四处一词是被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLDW3b.html" rel="bookmark" class="title">IBM的MARS加密算法实现&lpar;下&rpar;</a>
					<div>
						2.3 密文解密 用于密文解密的40个子密钥的生成和明文加密时的40个子密钥的生成方法相同. 2.3.1 第一步前向混合 输入的128位密文分成四块D[0],D[1],D[2],D[3],选取生成的4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY29d9p.html" rel="bookmark" class="title">微软将淘汰SHA-1和RC4加密算法</a>
					<div>
						微软官方博客宣布,2016年之后,该公司的软件将识别使用SHA-1哈希算法的数字证书为无效.它还同时建议客户停止在软件和应用中使用 RC4加密算法.SHA-1和其它哈希算法容易受到碰撞攻击.当两个不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY23g6p.html" rel="bookmark" class="title">SqlServersubstring&lpar;expression&comma;start&comma;length&rpar;函数</a>
					<div>
						  1 2 Syntax for SUBSTRING:  SUBSTRING(expression, start, length) expression 字符串.二进制字符串.文本.图像.列或包含列的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOeKkM.html" rel="bookmark" class="title">Photoshop打造出美女忧郁的脸</a>
					<div>
						  先看一下效果:         注:更多请关注photoshop教程栏目,三联PS教程群:181754111欢迎你的加入 分类: PS鼠绘教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl0gPz.html" rel="bookmark" class="title">Photoshop路径造型做连体字特效</a>
					<div>
						首先在Photoshop中新建文档,大小自定. 把文字打上去,将文字转为路径形状. 到路径面中点出路径. 用钢笔尖画出流线 线条,注意结合的部位. 分类: PS文字教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7B1WM.html" rel="bookmark" class="title">Python编程入门的一些基本知识</a>
					<div>
						  这篇文章主要介绍了Python编程入门的一些基本知识,包括注释需和Shell命令使用等基本内容,要的朋友可以参考下 Python与Perl,C和Java语言等有许多相似之处.不过,也有语言之间有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYqajM.html" rel="bookmark" class="title">DNN和windows azure？</a>
					<div>
						问题描述 DNN和windows azure? windows azure需要添加一个Webapplication做为web角色部署在云中,为什么DNN不能兼容在windows azure中,如果有人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3kLAM.html" rel="bookmark" class="title">word文档-求教NOPI生成Word文档及相关操作方法</a>
					<div>
						问题描述 求教NOPI生成Word文档及相关操作方法 各位大神,如果使用NPOI创建word文档? 如 创建一个table怎样合并单元格 如何插入页头.页尾.页码 如何插入分页符 如何插入图片 等等  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLBOmb.html" rel="bookmark" class="title">FPGA中浮点运算实现方法&mdash;&mdash;定标</a>
					<div>
						有些FPGA中是不能直接对浮点数进行操作的,只能采用定点数进行数值运算.对于FPGA而言,参与数学运算的书就是16位的整型数,但如果数学运算中出现小数怎么办呢?要知道,FPGA对小数是无能为力的,一种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o3Zqb.html" rel="bookmark" class="title">odi安装报错 ~~~跪求~~</a>
					<div>
						问题描述 odi安装报错 ~~~跪求~~ 在安装fmw_12.2.1.0.0_odi.jar时候报这个问题,我用的是1.8 的jdk 而且是在jdk的bin目录下执行的 求解答					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZrR3b.html" rel="bookmark" class="title">百度急需重生</a>
					<div>
						不管李彦宏承不承认,百度患上了大企业病.在内部喊出&quot;呼唤狼性.赶走小资&quot;的口号,就是最有力的证明.正所谓喊什么缺什么,百度喊要有狼性,正是缺乏狼性在作怪.   林军 有看官也许会说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YkXAM.html" rel="bookmark" class="title">Seo网站优化排名技术</a>
					<div>
						Seo网站优化排名技术 事情的起因,老板接了一个网站 http://www.111cn.net,客户提出要求说要优化.我也没在意,因为对SEO懂点皮毛,也权当练手了.随便在别的网站上复制了点东西.完全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvraJNM.html" rel="bookmark" class="title">Java与Node&period;js的较量－－一场史诗之战</a>
					<div>
						纵观整个计算机发展史,1995是疯狂的一年:这一年Java语言诞生,紧跟其后的是JavaScript.后者虽然含有java二字,实际和java并不沾亲带故.Java属于静态编程语言,需要编译:而Jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlQVkb.html" rel="bookmark" class="title">前端程序员应该知道的 15 个 jQuery 小技巧</a>
					<div>
						下面这些简单的小技巧能够帮助你玩转jQuery. 返回顶部按钮 预加载图像 检查图像是否加载 自动修复破坏的图像 悬停切换类 禁用输入字段 停止加载链接 切换淡入/幻灯片 简单的手风琴 让两个div高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bam9KQb.html" rel="bookmark" class="title">ERLANG实现快速排序算法</a>
					<div>
						问题描述 快速排序算法的思路:就是选择一个数,将比它小的放到它的一侧,比它大的放到另外一侧;然后将两侧继续递归下去按照这个方法进行排序直到排序完成.这里演示的是ERLANG的列表解析用法.然后来整理下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Jowz.html" rel="bookmark" class="title">&lbrack;华为机试练习题&rsqb;59&period;奖金提成</a>
					<div>
						题目 描述: 简要描述:企业发放的奖金根据利润提成. 利润低于或等于100000元的,奖金可提10%: 利润高于100000元,低于200000元(100000≤200000)时: 低于100000元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NP9Wz.html" rel="bookmark" class="title">学习Spark&mdash;&mdash;那些让你精疲力尽的坑</a>
					<div>
						这一个月我都干了些什么-- 工作上,还是一如既往的写bug并不亦乐乎的修bug.学习上,最近看了一些非专业书籍,写点小感悟,我刚稍稍瞄了下,最近五篇居然都跟技术无关,看来我与本行业已经是渐行渐远了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PE23p.html" rel="bookmark" class="title">主函数中的for循环时，每一个node都会分配一个nextNode吗？可是nextNode是成员变量，只有一个没有new啊！求解</a>
					<div>
						问题描述 packageDataStructor;classDat{Stringkey;Stringname;intage;}classCLType{DatnodeData=newDat();CLTy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEe5Az.html" rel="bookmark" class="title">控件-vs2008中使用mfc画图问题，新手求问。。</a>
					<div>
						问题描述 vs2008中使用mfc画图问题,新手求问.. 通过串口接收数据,然后画图,用已知的数据画出的图像是个圆形,一秒一个点..本来想用mschart控件,但是不知道怎么用这个控件画圆..所以麻烦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6wZ3M.html" rel="bookmark" class="title">ArcGIS 服务对象扩展（SOE）新手自学笔记（4）：Schema、Resource、Operation</a>
					<div>
						前面几节我们介绍了SOE基本概念.REST SOE模板以及如何处理输入输出数据.今天详细介绍一下SOE中三个重要概念:Schema.Resource.Operation. 1.Schema SOE中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba71Qwp.html" rel="bookmark" class="title">mysql存储过程，使用的navicat，给变量赋值的简单问题</a>
					<div>
						问题描述 mysql存储过程,使用的navicat,给变量赋值的简单问题 刚刚开始学习存储过程,看了不少资源,都没有解决我的问题,英文不是很好,看不太懂api,所以提交到这里问问各位老师,问题很简单, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rGr7z.html" rel="bookmark" class="title">IT运维人员如何才能实现长假前后不加班？</a>
					<div>
						问题描述 2013年第一个小长假又要到了,对于很多人来说又可以小放松一下.但是当大家踏青赏景休闲的时候,却有这样一群人还在忙碌着,他们就是--IT运维管理员们.其实很多IT运维管理人员在各个小长假和长 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A3OBz.html" rel="bookmark" class="title">unity武器拆装-如果要在3D状态下实现对物体的拆装，怎么办？</a>
					<div>
						问题描述 如果要在3D状态下实现对物体的拆装,怎么办? 我现在想用unity做对武器的拆装,最后能实现人机互动,想到用自动寻径的方法,怎么实现呢?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqEkWb.html" rel="bookmark" class="title">ie 7-怎么让灰色层的在上面啊？ie7 css</a>
					<div>
						问题描述 怎么让灰色层的在上面啊?ie7 css 解决方案 有个属性叫z-index 解决方案二: 有个属性叫z-index 解决方案三: 如果灰色层是li里面的div,要设置父容器的z-index, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAOJOb.html" rel="bookmark" class="title">java-一个值得深思的问题。</a>
					<div>
						问题描述 一个值得深思的问题. public class FinallyTest { public int test() { int i = 0; try { i++; return i; } fin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkDmXz.html" rel="bookmark" class="title">node&period;js-Javascript中的DOMContentLoaded事件？</a>
					<div>
						问题描述 Javascript中的DOMContentLoaded事件? 我看了MDN上的文档 DOMContentLoaded事件跟load事件一样,是针对document这个对象的. The DO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkNWoM.html" rel="bookmark" class="title">微信多开器 哪位大神给我讲讲 微信多开器的实现</a>
					<div>
						问题描述 微信多开器 哪位大神给我讲讲 微信多开器的实现 哪位大神给我讲讲 微信多开器的实现 哪位大神给我讲讲 微信多开器的实现 解决方案 http://download.csdn.net/detai ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBdmLb.html" rel="bookmark" class="title">短文本分析----基于python的TF-IDF特征词标签自动化提取</a>
					<div>
						绪论 最近做课题,需要分析短文本的标签,在短时间内学习了自然语言处理,社会标签推荐等非常时髦的技术.我们的需求非常类似于从大量短文本中获取关键词(融合社会标签和时间属性)进行用户画像.这一切的基础就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLJJL8b.html" rel="bookmark" class="title">实例剖析&colon;如何分析关键词对于我们站点的价值</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 关键词的分析在我们的优化推广历程中,一直都是一个不可忽视的关键环节,不管是我们是在建站之初对于站点的发展定位.还是在站点的运营中个对于关键词的布局,或者 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
